var cfg = require('../../cfg.json');
var fs = require('fs');
var http = require("http");
var https = require("https");
var mysql = require('mysql');
var bot = require('coffea')();
const path = require('path');

cfg.server.forEach((e,i,a) => {
  bot.add({
    "name": e.name,
    "host": e.host,
    "port": e.port,
    "ssl": e.ssl,
    "ssl_allow_invalid": e.ssl_allow_invalid,
    "pass": e.pass,
    "nick": e.nick,
    "username": e.username,
    "realname": e.realname
  });
  console.log("Server "+e.name+" wurden geladen");
});

bot.on('motd', (e) => {
  console.log("motd von "+e.network+" erhalten");
  bot.write('MODE f0ck +B', e.network, (c)=>{}); // Botflag
});

bot.on('message', (e) => {
  var orig = e.message;
  if(e.channel.getName().toString() == "#f0ck") { // (debug) only in channel #f0ck
    if(orig.match(/https?:\/\/[\w-]+(\.[\w-]+)+\.?(:\d+)?(\/\S*)?/gi)) { // shitpostcatcher
      var tmp = orig.match(/https?:\/\/[\w-]+(\.[\w-]+)+\.?(:\d+)?(\/\S*)?/gi); // get links
      tmp.forEach((entry,i,a) => {
        dl(entry, "./b/"+path.parse(entry).base, (cb) => { // download item
          e.reply(cb);
        });
      });
    }
	else if(orig.match(/^\.user/)) { // (debug) get userinfos
      var tmp = getUser(e.user.getNick(), e.network);
      setTimeout(()=>{ e.reply(tmp); }, 2000);
    }
  }
});


var getUser = (u, n) => {
  bot.whois(u, n, (fn)=>{ }); // send whois
  var start = Date.now();
  while(Date.now() < start + 2000) {} // block script for catch whois
  return bot.getUser(u, n);
};

var dl = (url, dest, cb) => {
  var file = fs.createWriteStream(dest);
  if(url.match(/https/)) {
    var request = https.get(url, (response) => {
      try {
        response.pipe(file);
        file.on('finish', () => {
          file.close();
          cb('(https) downloaded '+dest);
        });
        file.on('error', (err) => {
          fs.unlink(dest);
	      file.close();
          cb(err.message);
        });
	  }
	  catch(ex) {
        e.reply(ex);
      }
    });
  }
  else {
    var request = http.get(url, (response) => {
      try {
        response.pipe(file);
        file.on('finish', () => {
          file.close();
          cb('(http) downloaded '+dest);
        });
        file.on('error', (err) => {
          fs.unlink(dest);
	      file.close();
          cb(err.message);
        });
	  }
	  catch(ex) {
        e.reply(ex);
      }
    });
  }
}